#ifndef FITNESS_H
#define FITNESS_H

#include <eo>
#include <iostream>   // cout
#include <fstream>
#include <vector>

#include "obr.h"

using namespace std;

#define COLORS 16



class PaletteIndividual : public EO<double> {


public:

  PaletteIndividual() { palette.resize(COLORS); } 

  Pixel operator[](int i) const { return palette[i]; }; 
  Pixel& operator[](int i) { return palette[i]; }

  void resize(int N) { palette.resize(N);  }
  unsigned size() const { return palette.size(); }

  virtual std::string className() const {
    return "PaletteIndividual";
  }
 
  virtual void printOn(std::ostream& os) const {
    EO<double>::printOn(os);
    for (unsigned i=0; i<palette.size(); i++) 
      os << " (" << palette[i].r << "," << palette[i].g << "," << palette[i].b << ")"; 
  }
  
  virtual void readFrom(std::istream& is)   {
    // not implemented
    // neni treba implementovat (dokud nebudeme chtit populaci ukladat a znovu nacitat) 
  }


  //private:
  vector<Pixel> palette;
}; 



class MyFitness :  public eoEvalFunc<PaletteIndividual> {

public:
 
  MyFitness(Picture& _target) : target(_target) {
    // inicializace, pokud je potreba 
  };

   virtual void operator() (PaletteIndividual& ind)   {

     // spoctete hodnotu fitness 
     
     // ind.fitness( hodnota_fitness ); 
     
   };     

private:
  Picture& target;  // vzorovy obrazek
};

#endif
